/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  main.c
*  :  Liut
*  :  V1.00
*  :  2017/07/13
*  :  ʾ
          ͺţ28BYJ-48ʽΪ48
          K5л״̬ת-ֹͣ-ת-ֹͣ
*  ע:  ESSDK-GDB-ES8H296 V1.0
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "main.h"

int main(void)
{
    GPIO_InitStruType x;

    SystemClockConfig();                //ʱ
    DeviceClockAllEnable();             //ʱ

    SysTickInit();                      //ϵͳδʼ
    MotorInit();                        //ʼ

    GPIO_RegUnLock();
    x.GPIO_Func = GPIO_Func_0;
    x.GPIO_Direction = GPIO_Dir_In;
    x.GPIO_PUEN = ENABLE;
    GPIO_Init(GPIOB, GPIO_Pin_4, &x);  //ʼK5
    GPIO_RegLock();

    step_code = 0;                      //
    motor_state = 0;                    //״̬־
    key_press_flag = 0;                 //尴־

    while (1)
    {
        switch (motor_state)            //жϵ״̬
        {
            case 0:                     //ת
                temp = (((uint32_t)(MotorFW[step_code] & 0x01)) << 23) |
                       (((uint32_t)(MotorFW[step_code] & 0x02)) << 21) |
                       (((uint32_t)(MotorFW[step_code] & 0x04)) << 19) |
                       (((uint32_t)(MotorFW[step_code] & 0x08)) << 17);
                GPIO_Write(GPIOA, temp);
                step_code++;

                if (step_code >= 8)
                {
                    step_code = 0;
                }

                Delay100us(15);
                break;

            case 2:                     //ת
                temp = (((uint32_t)(MotorRW[step_code] & 0x01)) << 23) |
                       (((uint32_t)(MotorRW[step_code] & 0x02)) << 21) |
                       (((uint32_t)(MotorRW[step_code] & 0x04)) << 19) |
                       (((uint32_t)(MotorRW[step_code] & 0x08)) << 17);
                GPIO_Write(GPIOA, temp);
                step_code++;

                if (step_code >= 8)
                {
                    step_code = 0;
                }

                Delay100us(15);
                break;

            default:                    //ֹͣ
                break;
        }

        if ((GPIO_ReadBit(GPIOB, GPIO_Pin_4) == 0) && (key_press_flag == 0))   //жK5ʼ£л״̬ת-ֹͣ-ת-ֹͣ
        {
            Delay100us(200);            //20msȥ

            if (GPIO_ReadBit(GPIOB, GPIO_Pin_4) == 0)   //жK5״̬
            {
                key_press_flag = 1;      //浱ǰ־
                motor_state++;           //״̬+1

                if (motor_state >= 4)    //״̬0~3
                {
                    motor_state = 0;
                }
            }
        }
        else if ((GPIO_ReadBit(GPIOB, GPIO_Pin_4) == 1) && (key_press_flag == 1))   //жK5ͷ
        {
            key_press_flag = 0;            //尴־
        }
    }
}
