/*********************************************************
*Copyright (C), 2018, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  main.c
*  :  Liut
*  :  V1.00
*  :  2018/07/04
*  :  APP_Systickʾ
          GPIOPC15
              ʾοĵ AN082_Ӧñʼ_ES8HϵMCU bootloader
*  ע:  ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "ES8H296.h"

uint32_t count;
/***************************************************************
systick_init
  : Systickʼ
ֵ
ֵ
ֵ
***************************************************************/
void systick_init(void)
{
    SysTick->CTRL = 0x07;
    SysTick->LOAD = 16000;  //ϵͳʱ16M1msһж
    SysTick->VAL = 0;
}

/***************************************************************
gpio_init
  : GPIOʼ
ֵ
ֵ
ֵ
***************************************************************/
void gpio_init(void)
{
    SCU->PROT.Word = 0X55AA6996;
    SCU->PCLKEN0.GPIO_EN = 1;

    GPIO->PBDIR.DIR_15 = 0 ;                //PB15
}

int SystemInit(void)
{
    return 0;
}

/***************************************************************
main
  : boot
ֵ
ֵ
ֵ
***************************************************************/
int main(void)
{
    gpio_init();
    systick_init();
    GPIO->PB.DATA_15 = 0;

    while (1)
    {
    }
}

/***************************************************************
SysTick_Handler
  : SysTickжϷ
ֵ
ֵ
ֵ
***************************************************************/
void SysTick_IRQHandler(void)
{
    count++;

    if (count > 200)
    {
        count = 0;
        GPIO->PBI.Word = 1U << 15;
    }
}
