 /*********************************************************
*Copyright (C), 2015, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  lib_flashiap.h
*  :  
*  :  V1.00
*  :  2015/12/03
*  :  FlashIAP⺯ͷļ
*  ע:  HRSDK-GDB-8H296
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef __LIBIAP_H__
#define __LIBIAP_H__

#include "ES8H296.h"


/* IAP Function */
 uint8_t EraseAll (void) ;
 
 /* Ĵ */
#define FlashIAP_RegUnLock() (IAP->UL.IAPUL = 0x000000A5)
#define FlashIAP_RegLock()   (IAP->UL.IAPUL = 0x00000000)

/* ʹIAP */
#define FlashIAP_Enable()  (IAP->CON.EN = 0x1)
#define FlashIAP_Disable() (IAP->CON.EN = 0x0)

/* IAP */
#define FlashIAP_REQ() (IAP->CON.FLASH_REQ = 0x1)

 
//typedef uint32_t (*iap_pageerase_t)(uint32_t);
//#define  IAP_PageErase  ((iap_pageerase_t)(*((uint32_t *)0x10000000)))  

//typedef uint32_t (*iap_wordprogrm_t)(uint32_t, uint32_t);
//#define  IAP_WordProgram  ((iap_wordprogrm_t)(*((uint32_t *)0x10000004)))  

//typedef uint32_t (*iap_wordsprogrm_t)(uint32_t, uint32_t, uint32_t, uint32_t);
//#define  IAP_WordsProgram  ((iap_wordsprogrm_t)(*((uint32_t *)0x10000008)))  

uint32_t  get_cusum32(uint32_t* data_ptr, uint32_t len);

uint8_t check_empty(uint32_t* data_ptr, uint32_t len);


#define  REMAP_DIS   SCU->TBLRMEN.TBLREMAPEN=0;
#define  REMAP_EN    SCU->TBLRMEN.TBLREMAPEN=1;


#define  FAILED  0
#define  SUCCESS 1

uint8_t IAP_PageErase(uint8_t Page_Addr);
uint8_t FlashIap_WriteEnd(void);
uint8_t FlashIap_Unlock(void);
uint8_t IAP_WordsProgram(uint32_t iap_addr, uint32_t data_addr, uint32_t iap_len);

#endif
