/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  main.c
*  :  Liut
*  :  V1.00
*  :  2017/06/25
*  :  LCDʾ
          ϵʾ12:00Ȼʾʵʱʱ(עܽŸãڶλʾ)
         1K4ڷֵ
         2K3Сʱֵ
         3K1лʾģʽСʱ:ӡ/:롱
				  עʹⲿپLOSCENʹܣLCD32Kʱѡ
*  ע:  ESSDK-GDB-ES8H296 V1.0
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "main.h"

int main()
{
    SystemClockConfig();                      //ʱ
	SCU_LCD32K_RtcOsc();                      //ѡLCD32Kʱ
    DeviceClockAllEnable();                   //ʱ

    SCU_RegUnLock();
    SCU_LCDCCLK_Enable();
    SCU_T16N3CLK_Enable();
    SCU_RegLock();

    LCDInit();
    T16N3Init();
    KeyInit();

    GPIOA_SetBit(GPIO_Pin_20);                  //ϨLD4
    GPIOA_SetBit(GPIO_Pin_21);                  //ϨLD3
    GPIOA_SetBit(GPIO_Pin_22);                  //ϨLD2
    GPIOA_SetBit(GPIO_Pin_23);                  //ϨLD1

    g_display_flag = 0;
    g_hour_cnt = 12;                            //Сʱʼֵ=12
    g_minute_cnt = 00;                          //ӳʼֵ=00
    g_second_cnt = 00;                          //ʼֵ=00
    g_flick = 0;

    g_10ms_flag = 0;
    g_500ms_flag = 0;
    g_500ms_cnt = 0;

    while (1)
    {
        if (g_10ms_flag == 1)
        {
            g_10ms_flag = 0;
            key = KeyGetValue();

            switch (key)
            {
                case 4:                                     //K4ڷֵ
                    if (g_display_flag == 0)                //жʾģʽ־Ϊ0[Сʱ:]
                    {
                        g_minute_cnt++;                     //ֵ+1

                        if (g_minute_cnt >= 60)
                        {
                            g_minute_cnt = 0;               //600
                        }
                    }

                    break;

                case 3:                                     //K3Сʱֵ
                    if (g_display_flag == 0)                //жʾģʽ־Ϊ0[Сʱ:]
                    {
                        g_hour_cnt++;                       //Сʱֵ+1

                        if (g_hour_cnt >= 24)
                        {
                            g_hour_cnt = 0;                 //240
                        }
                    }

                    break;

                case 1:                                     //K1лʾģʽ
                    g_display_flag = ~g_display_flag;       //лʾģʽ
                    break;

                default:
                    key = 0;
                    break;
            }
        }

        if (g_500ms_flag == 1)
        {
            g_500ms_flag = 0;
            RealTime();                                     //ʵʱʱӳ

            if (g_display_flag == 0)                        //жʾģʽ־Ϊ0
            {
                LCDDisplayData(g_hour_cnt, g_minute_cnt, g_flick);      //ʾ[Сʱ:]
            }
            else                                            //жʾģʽ־Ϊ1
            {
                LCDDisplayData(g_minute_cnt, g_second_cnt, g_flick);    //ʾ[:]
            }
        }
    }
}
