/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  main.c
*  :  Liut
*  :  V1.00
*  :  2017/06/23
*  :  RTCʾ
        գֱܷһжϣжϾLD2-LD4
        жδLD2-LD4˸
*  ע:  ES8H296оƬ
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "main.h"

int main(void)
{
    SystemClockConfig();
    DeviceClockAllEnable();

    //SCU_OpenXTAL();

    SysTickInit();
    LightInit();

    GPIOA_SetBit(GPIO_Pin_20);          //ϨLD1
    GPIOA_SetBit(GPIO_Pin_21);          //ϨLD2
    GPIOA_SetBit(GPIO_Pin_22);          //ϨLD3
    GPIOA_SetBit(GPIO_Pin_23);          //ϨLD4

    g_day_flag = 0;
    g_week_flag = 0;

    RTC_Init(RTC_LRC, RTC_HOUR24);

    RTC_WriteHour(15, 0);
    RTC_WriteMinute(24);
    RTC_WriteSecond(58);

    RTC_WriteDayAlarmHour(15, 0);
    RTC_WriteDayAlarmMinute(25);
    RTC_InterruptEnable(RTC_Interrupt_Source_DayALE);
    Delay1ms(3000);

    RTC_WriteWeek(4);
    RTC_WriteMonth(7);
    RTC_WriteDay(6);
    RTC_WriteHour(16, 0);
    RTC_WriteMinute(24);
    RTC_WriteSecond(58);

    RTC_WriteWeekAlarmWeek(4);
    RTC_WriteWeekAlarmHour(16, 0);
    RTC_WriteWeekAlarmMinute(25);
    RTC_InterruptEnable(RTC_Interrupt_Source_WeekALE);
    Delay1ms(3000);

    while (1)
    {
        if (g_day_flag == 1 && g_week_flag == 1)
        {
            GPIOA_ResetBit(GPIO_Pin_20);
            GPIOA_ResetBit(GPIO_Pin_21);
            GPIOA_ResetBit(GPIO_Pin_22);
        }
        else
        {
            GPIOA_ResetBit(GPIO_Pin_20);
            GPIOA_ResetBit(GPIO_Pin_21);
            GPIOA_ResetBit(GPIO_Pin_22);
            Delay1ms(500);
            GPIOA_SetBit(GPIO_Pin_20);
            GPIOA_SetBit(GPIO_Pin_21);
            GPIOA_SetBit(GPIO_Pin_22);
            Delay1ms(500);
        }
    }
}
