/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  spi.h
*  :  Liut
*  :  V1.00
*  :  2017/06/26
*  :  SPIģͷļ
*  ע:  ESSDK-GDB-ES8H296 V1.1
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#ifndef __SPI_H__
#define __SPI_H__

#include "ES8H296.h"
#include "lib_config.h"
#include "lib_spi.h"
#include "lib_gpio.h"
#include "SysTick.h"

#define CS_SET GPIOB_SetBit(GPIO_Pin_21)
#define CS_RESET GPIOB_ResetBit(GPIO_Pin_21)
#define SCK_PIN GPIO_Pin_20
#define CS_PIN  GPIO_Pin_21
#define SDI_PIN GPIO_Pin_22
#define SDO_PIN GPIO_Pin_23

/*  */
void SPI_GPIO_Init(void);
void SPI_Ewen(void);
void SPI_Ewds(void);
void SPIReadData(uint8_t addr, uint8_t *buf, uint8_t n);
void SPIWriteData(uint8_t addr, uint8_t *buf, uint8_t n);
void SPIEraseAll(void);

#endif
