/*********************************************************
*Copyright (C), 2017, Shanghai Eastsoft Microelectronics Co., Ltd
*ļ:  timer.c
*  :  Liut
*  :  V1.00
*  :  2017/06/25
*  :  T16Nģ
*  ע:  ESSDK-GDB-ES8H296 V1.0
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "timer.h"

/*********************************************************
: void T16NxInit(void)
  : T16Nxʱʼ
ֵ: 
ֵ: 
ֵ: 
**********************************************************/
void T16NxInit(void)
{
    TIM_BaseInitStruType x;

    x.TIM_ClkS = TIM_ClkS_PCLK;
    x.TIM_SYNC = DISABLE;
    x.TIM_EDGE = TIM_EDGE_Rise;
    x.TIM_Mode = TIM_Mode_TC0;
    T16Nx_BaseInit(T16N0, &x);
    T16Nx_BaseInit(T16N1, &x);
    T16Nx_BaseInit(T16N2, &x);
    T16Nx_BaseInit(T16N3, &x);

    T16Nx_SetPREMAT(T16N0, 1);
    T16Nx_SetPREMAT(T16N1, 1);
    T16Nx_SetPREMAT(T16N2, 1);
    T16Nx_SetPREMAT(T16N3, 1);

    T16Nx_SetMAT0(T16N0, 40000);
    T16Nx_SetMAT0(T16N1, 40000);
    T16Nx_SetMAT0(T16N2, 40000);
    T16Nx_SetMAT0(T16N3, 40000);

    NVIC_Init(NVIC_T16N0_IRQn, NVIC_Priority_1, ENABLE);
    NVIC_Init(NVIC_T16N1_IRQn, NVIC_Priority_1, ENABLE);
    NVIC_Init(NVIC_T16N2_IRQn, NVIC_Priority_1, ENABLE);
    NVIC_Init(NVIC_T16N3_IRQn, NVIC_Priority_1, ENABLE);

    T16Nx_MAT0ITConfig(T16N0, TIM_Clr_Int);
    T16Nx_MAT0ITConfig(T16N1, TIM_Clr_Int);
    T16Nx_MAT0ITConfig(T16N2, TIM_Clr_Int);
    T16Nx_MAT0ITConfig(T16N3, TIM_Clr_Int);

    T16Nx_ITConfig(T16N0, TIM_IT_MAT0, ENABLE);
    T16Nx_ITConfig(T16N1, TIM_IT_MAT0, ENABLE);
    T16Nx_ITConfig(T16N2, TIM_IT_MAT0, ENABLE);
    T16Nx_ITConfig(T16N3, TIM_IT_MAT0, ENABLE);

    T16N0_Enable();
    T16N1_Enable();
    T16N2_Enable();
    T16N3_Enable();
}
